--- old/usr/src/lib/libproc/common/Pzone.c	Wed Aug 21 14:46:36 2013
+++ new/usr/src/lib/libproc/common/Pzone.c	Wed Aug 21 14:46:36 2013
@@ -25,6 +25,7 @@
  */
 /*
  * Copyright (c) 2013, Joyent, Inc. All rights reserved.
+ * Copyright (c) 2013 by Delphix. All rights reserved.
  */
 
 #include <assert.h>
@@ -231,23 +232,7 @@
 char *
 Pzonename(struct ps_prochandle *P, char *s, size_t n)
 {
-	if (P->state == PS_IDLE) {
-		errno = ENODATA;
-		return (NULL);
-	}
-
-	if (P->state == PS_DEAD) {
-		if (P->core->core_zonename == NULL) {
-			errno = ENODATA;
-			return (NULL);
-		}
-		(void) strlcpy(s, P->core->core_zonename, n);
-	} else {
-		if (getzonenamebyid(P->status.pr_zoneid, s, n) < 0)
-			return (NULL);
-		s[n - 1] = '\0';
-	}
-	return (s);
+	return (P->ops.pop_zonename(P, s, n, P->data));
 }
 
 char *
--- old/usr/src/lib/libproc/common/libproc.h	Wed Aug 21 14:46:37 2013
+++ new/usr/src/lib/libproc/common/libproc.h	Wed Aug 21 14:46:37 2013
@@ -26,6 +26,7 @@
  * Portions Copyright 2007 Chad Mynhier
  * Copyright 2012 DEY Storage Systems, Inc.  All rights reserved.
  * Copyright (c) 2013, Joyent, Inc. All rights reserved.
+ * Copyright (c) 2013 by Delphix. All rights reserved.
  */
 
 /*
@@ -127,6 +128,7 @@
 #define	PGRAB_FORCE	0x02	/* Open the process w/o O_EXCL */
 #define	PGRAB_RDONLY	0x04	/* Open the process or core w/ O_RDONLY */
 #define	PGRAB_NOSTOP	0x08	/* Open the process but do not stop it */
+#define	PGRAB_INCORE	0x10	/* Use in-core data to build symbol tables */
 
 /* Error codes from Pcreate() */
 #define	C_STRANGE	-1	/* Unanticipated error, errno is meaningful */
@@ -188,6 +190,55 @@
 #define	MAXARGL		(4*1024)
 
 /*
+ * Ops vector definition for the Pgrab_ops().
+ */
+typedef ssize_t (*pop_pread_t)(struct ps_prochandle *, void *, size_t,
+    uintptr_t, void *);
+typedef ssize_t (*pop_pwrite_t)(struct ps_prochandle *, const void *, size_t,
+    uintptr_t, void *);
+typedef int (*pop_read_maps_t)(struct ps_prochandle *, prmap_t **, ssize_t *,
+    void *);
+typedef void (*pop_read_aux_t)(struct ps_prochandle *, auxv_t **, int *,
+    void *);
+typedef int (*pop_cred_t)(struct ps_prochandle *, prcred_t *, int,
+    void *);
+typedef int (*pop_priv_t)(struct ps_prochandle *, prpriv_t **, void *);
+typedef const psinfo_t *(*pop_psinfo_t)(struct ps_prochandle *, psinfo_t *,
+    void *);
+typedef void (*pop_status_t)(struct ps_prochandle *, pstatus_t *, void *);
+typedef prheader_t *(*pop_lstatus_t)(struct ps_prochandle *, void *);
+typedef prheader_t *(*pop_lpsinfo_t)(struct ps_prochandle *, void *);
+typedef void (*pop_fini_t)(struct ps_prochandle *, void *);
+typedef char *(*pop_platform_t)(struct ps_prochandle *, char *, size_t, void *);
+typedef int (*pop_uname_t)(struct ps_prochandle *, struct utsname *, void *);
+typedef char *(*pop_zonename_t)(struct ps_prochandle *, char *, size_t, void *);
+typedef char *(*pop_execname_t)(struct ps_prochandle *, char *, size_t, void *);
+#if defined(__i386) || defined(__amd64)
+typedef int (*pop_ldt_t)(struct ps_prochandle *, struct ssd *, int, void *);
+#endif
+
+typedef struct ps_ops {
+	pop_pread_t		pop_pread;
+	pop_pwrite_t		pop_pwrite;
+	pop_read_maps_t		pop_read_maps;
+	pop_read_aux_t		pop_read_aux;
+	pop_cred_t		pop_cred;
+	pop_priv_t		pop_priv;
+	pop_psinfo_t		pop_psinfo;
+	pop_status_t		pop_status;
+	pop_lstatus_t		pop_lstatus;
+	pop_lpsinfo_t		pop_lpsinfo;
+	pop_fini_t		pop_fini;
+	pop_platform_t		pop_platform;
+	pop_uname_t		pop_uname;
+	pop_zonename_t		pop_zonename;
+	pop_execname_t		pop_execname;
+#if defined(__i386) || defined(__amd64)
+	pop_ldt_t		pop_ldt;
+#endif
+} ps_ops_t;
+
+/*
  * Function prototypes for routines in the process control package.
  */
 extern struct ps_prochandle *Pcreate(const char *, char *const *,
@@ -201,6 +252,7 @@
 extern struct ps_prochandle *Pgrab_core(const char *, const char *, int, int *);
 extern struct ps_prochandle *Pfgrab_core(int, const char *, int *);
 extern struct ps_prochandle *Pgrab_file(const char *, int *);
+extern struct ps_prochandle *Pgrab_ops(pid_t, void *, const ps_ops_t *, int);
 extern const char *Pgrab_error(int);
 
 extern	int	Preopen(struct ps_prochandle *);
@@ -221,7 +273,7 @@
 extern	const pstatus_t *Pstatus(struct ps_prochandle *);
 extern	int	Pcred(struct ps_prochandle *, prcred_t *, int);
 extern	int	Psetcred(struct ps_prochandle *, const prcred_t *);
-extern	ssize_t	Ppriv(struct ps_prochandle *, prpriv_t *, size_t);
+extern	int	Ppriv(struct ps_prochandle *, prpriv_t **);
 extern	int	Psetpriv(struct ps_prochandle *, prpriv_t *);
 extern	void   *Pprivinfo(struct ps_prochandle *);
 extern	int	Psetzoneid(struct ps_prochandle *, zoneid_t);
--- old/usr/src/lib/libproc/common/llib-lproc	Wed Aug 21 14:46:38 2013
+++ new/usr/src/lib/libproc/common/llib-lproc	Wed Aug 21 14:46:38 2013
@@ -25,6 +25,9 @@
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright (c) 2013 by Delphix. All rights reserved.
+ */
 #include "libproc.h"
 
 /*
@@ -46,7 +49,7 @@
 const psinfo_t *Ppsinfo(struct ps_prochandle *Pr);
 const pstatus_t *Pstatus(struct ps_prochandle *Pr);
 int	Pcred(struct ps_prochandle *Pr, prcred_t *pcrp, int ngroups);
-ssize_t	Ppriv(struct ps_prochandle *Pr, prpriv_t *pprivp, size_t);
+int	Ppriv(struct ps_prochandle *Pr, prpriv_t **pprivp);
 void	Psync(struct ps_prochandle *Pr);
 int	Pcreate_agent(struct ps_prochandle *Pr);
 void	Pdestroy_agent(struct ps_prochandle *Pr);
--- old/usr/src/lib/libproc/common/mapfile-vers	Wed Aug 21 14:46:39 2013
+++ new/usr/src/lib/libproc/common/mapfile-vers	Wed Aug 21 14:46:39 2013
@@ -22,6 +22,7 @@
 # Copyright (c) 2006, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright 2012 DEY Storage Systems, Inc.  All rights reserved.
 # Copyright (c) 2013, Joyent, Inc. All rights reserved.
+# Copyright (c) 2013 by Delphix. All rights reserved.
 #
 
 #
@@ -123,6 +124,7 @@
 	Pgrab_core;
 	Pgrab_error;
 	Pgrab_file;
+	Pgrab_ops;
 	Pisprocdir;
 	Pissyscall_prev;
 	Plmid;
--- old/usr/src/uts/common/sys/lwp.h	Wed Aug 21 14:46:40 2013
+++ new/usr/src/uts/common/sys/lwp.h	Wed Aug 21 14:46:40 2013
@@ -23,12 +23,13 @@
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright (c) 2013 by Delphix. All rights reserved.
+ */
 
 #ifndef	_SYS_LWP_H
 #define	_SYS_LWP_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/synch.h>
 #include <sys/ucontext.h>
 
@@ -64,6 +65,8 @@
 
 #endif	/* _SYSCALL32 */
 
+typedef uint_t lwpid_t;
+
 #define	_LWP_FSBASE	0
 #define	_LWP_GSBASE	1
 
@@ -72,8 +75,6 @@
 
 #ifndef _KERNEL
 
-typedef uint_t lwpid_t;
-
 int		_lwp_kill(lwpid_t, int);
 int		_lwp_info(struct lwpinfo *);
 lwpid_t		_lwp_self(void);
--- old/usr/src/uts/common/sys/syscall.h	Wed Aug 21 14:46:42 2013
+++ new/usr/src/uts/common/sys/syscall.h	Wed Aug 21 14:46:42 2013
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2013 by Delphix. All rights reserved.
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
@@ -498,13 +499,13 @@
 	unsigned int	word[16];
 } sysset_t;
 
-#if !defined(_KERNEL)
-
 typedef struct {	/* return values from system call */
 	long	sys_rval1;	/* primary return value from system call */
 	long	sys_rval2;	/* second return value from system call */
 } sysret_t;
 
+#if !defined(_KERNEL)
+
 #if defined(__STDC__)
 extern int	syscall(int, ...);
 extern int	__systemcall(sysret_t *, int, ...);
